--JD820
--hz888


JD820 = {}

function JD820.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cutter, specializations);
end;

function JD820:load(xmlFile)

    local fogNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fog#index"));
    if fogNode ~= nil then
        self.fog = {};
        self.fog.node = fogNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.fog#minTrans"));
        self.fog.minTrans = {};
        self.fog.minTrans[1] = Utils.getNoNil(x, 0);
        self.fog.minTrans[2] = Utils.getNoNil(y, 0);
        self.fog.minTrans[3] = Utils.getNoNil(z, 0);


		 local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    for i=1, numCuttingAreas do
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea%d", i);
        self.cuttingAreas[i].foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMinLimit"), 0);
        self.cuttingAreas[i].foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMaxLimit"), 1);

    end;

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.fog#maxTrans"));
        self.fog.maxTrans = {};
        self.fog.maxTrans[1] = Utils.getNoNil(x, 0);
        self.fog.maxTrans[2] = Utils.getNoNil(y, 0);
        self.fog.maxTrans[3] = Utils.getNoNil(z, 0);

        self.fog.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.fog#transTime"), 2)*1000;
        self.fog.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.fog#touchTransLimit"), 10);
		self.motovilo = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.motovilo#index"));
		self.grabla = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.grabla#index"));
		self.grablb = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.grablb#index"));
		self.grablc = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.grablc#index"));
		self.grabld = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.grabld#index"));
		self.grable = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.grable#index"));
		self.moto = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.moto#index"));
		self.shnek = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.shnek#index"));
          self.sledm = 0;
		  self.motowkl = -1;
          self.regmoto = 5;
		  self.wasToFast = false;
    end;

end;

function JD820:delete()
end;

function JD820:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JD820:keyEvent(unicode, sym, modifier, isDown)
if isDown and sym == Input.KEY_g then
		self.motowkl = self.motowkl * -1;
	end;
end;

function JD820:update(dt)



if InputBinding.isPressed(InputBinding.MOTOWERH) then
    if self.sledm <= 100 then
        rotate(self.moto, 0.002, 0, 0);
        self.sledm = self.sledm + 1;
    end;
end;

if InputBinding.isPressed(InputBinding.MOTONIZ) then
    if self.sledm >= 1 then
        rotate(self.moto, -0.002, 0, 0);
        self.sledm = self.sledm - 1;
     end;
end;

if InputBinding.isPressed(InputBinding.REGMOTOWERH) then
    if self.regmoto <= 15 then
        self.regmoto = self.regmoto + 0.5;
  end;
end;

if InputBinding.isPressed(InputBinding.REGMOTONIZ) then
    if self.regmoto >= 5 then
        self.regmoto = self.regmoto - 0.5;
  end;
end;


   if self.motowkl >= 0 then
         if self.shnek ~= nil then
		rotate(self.shnek, 0.1, 0, 0);
         end;

	     if self.motovilo ~= nil then
		rotate(self.motovilo, -self.regmoto*0.006, 0, 0);
         end;
	     if self.grabla ~= nil then
		rotate(self.grabla, self.regmoto*0.006, 0, 0);
         end;
	     if self.grablb ~= nil then
		rotate(self.grablb, self.regmoto*0.006, 0, 0);
         end;
	     if self.grablc ~= nil then
		rotate(self.grablc, self.regmoto*0.006, 0, 0);
         end;
	     if self.grabld ~= nil then
		rotate(self.grabld, self.regmoto*0.006, 0, 0);
         end;
	     if self.grable ~= nil then
		rotate(self.grable, self.regmoto*0.006, 0, 0);
         end;
   end;

   -----------------------------------------------------------------------------------------------

   if self.motowkl >= 0  then


            local toFast = self:doCheckSpeedLimit() and self.lastSpeed*3600 > 31;
            if not toFast then
                local x,y,z = getWorldTranslation(self.groundReferenceNode);
				local foldAnimTime = self.foldAnimTime;

				local area = 0;
				local areaWheat = 0;
				local areaBarley = 0;

				for k, cuttingArea in pairs(self.cuttingAreas) do

					local x,y,z = getWorldTranslation(cuttingArea.start);
					local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
					local x2,y2,z2 = getWorldTranslation(cuttingArea.height);

					if k == 1 then
						area = Utils.updateMeadowArea(x, z, x1, z1, x2, z2);
						areaWheat = Utils.cutFruitArea(FruitUtil.FRUITTYPE_WHEAT, x, z, x1, z1, x2, z2);
						areaBarley = Utils.cutFruitArea(FruitUtil.FRUITTYPE_BARLEY, x, z, x1, z1, x2, z2);

						if self.attacherVehicle.movingDirection ~= -1 then
							area = area + Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, 0);
						else
							if areaWheat > 0 then
								local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_WHEAT, x, z, x1, z1, x2, z2);
								local value = 1+math.floor(old / total + 0.7);
								value = math.min(value, g_currentMission.maxWindrowValue);
								Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_WHEAT, x, z, x1, z1, x2, z2, value, true);
							end;

							if areaBarley > 0 then
								local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_BARLEY, x, z, x1, z1, x2, z2);
								local value = 1+math.floor(old / total + 0.7);
								value = math.min(value, g_currentMission.maxWindrowValue);
								Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_BARLEY, x, z, x1, z1, x2, z2, value, true);
							end;
						end;

						if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 30 then
							if area > 0 or areaWheat > 0 or areaBarley > 0 then
								if cuttingArea.grassParticleSystemIndex ~= nil then
									ps = self.grassParticleSystems[cuttingArea.grassParticleSystemIndex+1];
									if ps ~= nil then
										ps.disableTime = self.time + 20;
										Utils.setEmittingState(ps.ps, true);
									end;
								end;
							end;
						end;

					else
						if self.attacherVehicle.movingDirection ~= -1 then
							if area > 0 then
								local old, total = Utils.getFruitCutLongArea(FruitUtil.FRUITTYPE_DRYGRASS, x, z, x1, z1, x2, z2);
								local value = 1+math.floor(old / total + 0.7);
								value = math.min(value, g_currentMission.maxWindrowValue);
								Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, value, true);
							end;

							if areaWheat > 0 then
								local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_WHEAT, x, z, x1, z1, x2, z2);
								local value = 1+math.floor(old / total + 0.7);
								value = math.min(value, g_currentMission.maxWindrowValue);
								Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_WHEAT, x, z, x1, z1, x2, z2, value, true);
							end;

							if areaBarley > 0 then
								local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_BARLEY, x, z, x1, z1, x2, z2);
								local value = 1+math.floor(old / total + 0.7);
								value = math.min(value, g_currentMission.maxWindrowValue);
								Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_BARLEY, x, z, x1, z1, x2, z2, value, true);
							end;
						end;
					end;
				end;
            end;
   self.wasToFast = toFast;

   end;
   -----------------------------------------------------------------------------




    if self.reelStarted then

    	if self.fog ~= nil then
		local x, y, z = getTranslation(self.fog.node);
		local trans = {x,y,z};
		if x <= self.fog.minTrans[1] then
			self.fogMax = true;
		elseif x >= self.fog.maxTrans[1] then
			self.fogMax = false;
		end;
		local newTrans = Utils.getMovedLimitedValues(trans, self.fog.maxTrans, self.fog.minTrans, 3, self.fog.transTime, dt, not self.fogMax);
		setTranslation(self.fog.node, unpack(newTrans));
	end;
    end;
end;

function JD820:draw()
end;
